# midiport.h File Reference

`#include <jack/types.h>`
`#include <stdlib.h>`

Go to the source code of this file.

## Data Structures
struct | _jack_midi_event
## Typedefs
typedef unsigned char | jack_midi_data_t
typedef _jack_midi_event | jack_midi_event_t
## Functions
jack_nframes_t | jack_midi_get_event_count (void *port_buffer, jack_nframes_t nframes)
int | jack_midi_event_get (jack_midi_event_t *event, void *port_buffer, jack_nframes_t event_index, jack_nframes_t nframes)
void | jack_midi_clear_buffer (void *port_buffer, jack_nframes_t nframes)
size_t | jack_midi_max_event_size (void *port_buffer, jack_nframes_t nframes)
jack_midi_data_t * | jack_midi_event_reserve (void *port_buffer, jack_nframes_t time, size_t data_size, jack_nframes_t nframes)
int | jack_midi_event_write (void *port_buffer, jack_nframes_t time, const jack_midi_data_t *data, size_t data_size, jack_nframes_t nframes)
jack_nframes_t | jack_midi_get_lost_event_count (void *port_buffer, jack_nframes_t nframes)

## Typedef Documentation

typedef unsigned char jack_midi_data_t

| Type for raw event data contained in jack_midi_event_t.

typedef struct _jack_midi_event jack_midi_event_t

| A Jack MIDI event.

## Function Documentation

void jack_midi_clear_buffer | ( | void * | port_buffer,
|  | jack_nframes_t | nframes
| ) |

  | Clear an event buffer. This should be called at the beginning of each process cycle before calling jack_midi_event_reserve or jack_midi_event_write. This function may not be called on an input port's buffer. Parameters:
  | port_buffer | Port buffer to clear (must be an output port buffer).
  | nframes | Number of valid frames this cycle.

int jack_midi_event_get | ( | jack_midi_event_t * | event,
|  | void * | port_buffer,
|  | jack_nframes_t | event_index,
|  | jack_nframes_t | nframes
| ) |

  | Get a MIDI event from an event port buffer. Jack MIDI is normalised, the MIDI event returned by this function is guaranteed to be a complete MIDI event (the status byte will always be present, and no realtime events will interspered with the event). Parameters:
  | event | Event structure to store retrieved event in.
  | port_buffer | Port buffer from which to retrieve event.
  | event_index | Index of event to retrieve.
  | nframes | Number of valid frames this cycle.
Returns: 0 on success, ENODATA if buffer is empty.

jack_midi_data_t* jack_midi_event_reserve | ( | void * | port_buffer,
|  | jack_nframes_t | time,
|  | size_t | data_size,
|  | jack_nframes_t | nframes
| ) |

  | Allocate space for an event to be written to an event port buffer. Clients are to write the actual event data to be written starting at the pointer returned by this function. Clients must not write more than data_size bytes into this buffer. Clients must write normalised MIDI data to the port - no running status and no (1-byte) realtime messages interspersed with other messages (realtime messages are fine when they occur on their own, like other messages). Parameters:
  | port_buffer | Buffer to write event to.
  | time | Sample offset of event.
  | data_size | Length of event's raw data in bytes.
  | nframes | Number of valid frames this event.
Returns: Pointer to the beginning of the reserved event's data buffer, or NULL on error (ie not enough space).

int jack_midi_event_write | ( | void * | port_buffer,
|  | jack_nframes_t | time,
|  | const jack_midi_data_t * | data,
|  | size_t | data_size,
|  | jack_nframes_t | nframes
| ) |

  | Write an event into an event port buffer. This function is simply a wrapper for jack_midi_event_reserve which writes the event data into the space reserved in the buffer. The same restrictions on the MIDI data apply. Parameters:
  | port_buffer | Buffer to write event to.
  | time | Sample offset of event.
  | data | Message data to be written.
  | data_size | Length of data in bytes.
  | nframes | Number of valid frames this event.
Returns: 0 on success, ENOBUFS if there's not enough space in buffer for event.

jack_nframes_t jack_midi_get_event_count | ( | void * | port_buffer,
|  | jack_nframes_t | nframes
| ) |

jack_nframes_t jack_midi_get_lost_event_count | ( | void * | port_buffer,
|  | jack_nframes_t | nframes
| ) |

  | Get the number of events that could not be written to port_buffer. This function returning a non-zero value implies port_buffer is full. Currently the only way this can happen is if events are lost on port mixdown. Parameters:
  | port_buffer | Port to receive count for.
  | nframes | Number of valid frames this cycle.
Returns: Number of events that could not be written to port_buffer.

size_t jack_midi_max_event_size | ( | void * | port_buffer,
|  | jack_nframes_t | nframes
| ) |

  | Get the size of the largest event that can be stored by the port. This function returns the current space available, taking into account events already stored in the port. Parameters:
  | port_buffer | Port buffer to check size of.
  | nframes | Number of valid frames this cycle.